﻿'From Pharo1.2.1 of 2 April 2011 [Latest update: #12345] on 9 April 2011 at 10:17:59 pm'!
AbstractTutorial subclass: #SmalltalkSyntaxTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Core'!
!SmalltalkSyntaxTutorial commentStamp: 'LaurentLaffont 1/21/2010 16:50' prior: 0!
The default ProfStef tutorial to learn Smalltalk syntax!


!SmalltalkSyntaxTutorial methodsFor: 'initialize-release' stamp: 'LaurentLaffont 12/12/2010 17:18'!
initialize
	super initialize.
	self prepareDebuggerExample.! !


!SmalltalkSyntaxTutorial methodsFor: 'interactive' stamp: 'EiichiroIto 4/9/2011 22:17'!
divideTwoByZero

	
	"おっと！ 2/0 がZeroDivide例外を発生させました。このプログラムを修正するためにデバッガが開かれました。
	
	- 上の１行のプログラムを削除します。
	- 右クリックしてAcceptを選び、このメソッドの新しいバージョンをコンパイルします。
	- Proceedを押して、実行を続けます。
	".
	ProfStef next. ! !

!SmalltalkSyntaxTutorial methodsFor: 'interactive' stamp: 'EiichiroIto 4/9/2011 19:39'!
prepareDebuggerExample
	self class compile: 'divideTwoByZero
	2/0.
	
	"おっと！ 2/0 がZeroDivide例外を発生させました。このプログラムを修正するためにデバッガが開かれました。
	
	- 上の１行のプログラムを削除します。
	- 右クリックしてAcceptを選び、このメソッドの新しいバージョンをコンパイルします。
	- Proceedを押して、実行を続けます。
	".
	ProfStef next. ' classified: 'interactive'! !


!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:56'!
basicTypesArray
	^ Lesson title: 'Basic types: Array' lesson: '"静的（リテラル）配列は、構文解析時に生成されます。"

#(1 2 3).

#( 1 2 3 #(4 5 6)) size.

#(1 2 4) isEmpty.

#(1 2 3) first.

#(''こんにちは'' ''Squeak'') at: 2 put: ''Pharo''; yourself.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/7/2011 20:55'!
basicTypesCharacters
	^ Lesson title: 'Basic types: Characters' lesson: '"$演算子を使うことで文字を作ることができます。"

$A.

$A class.

$B charCode.

Character cr.

Character space.

"ASCII拡張集合に含まれる256文字全てを表示することもできます。"

Character allByteCharacters.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:56'!
basicTypesDynamicArray
	^ Lesson title: 'Basic types: Dynamic Array' lesson: '"動的配列は、実行時に生成されます。"

{ (2+3) . (6*6) }.

{ (2+3) . (6*6) . ''こんにちは'', '' Stef''} size.


{ ProfStef } first next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:50'!
basicTypesNumbers
	^ Lesson title: 'Basic types: Numbers' lesson: '"これでSmalltalkのプログラムを実行する方法がわかりました。

では、基本的なオブジェクトについて話しましょう。

1, 2, 100, 2/3 ... は数で、数式に評価する多くのメッセージに反応します。
いくつか試してみましょう"

2.

20 factorial.

1000 factorial / 999 factorial.

(1/3).

(1/3) + (4/5).

(1/3) asFloat.

1 class.

1 class maxVal class.

(1 class maxVal + 1) class.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:54'!
basicTypesString
	^ Lesson title: 'Basic types: Strings' lesson: '"文字列は文字の集まりです。文字列オブジェクトを作るには、シングルクオートで囲みます。これらの式を示します。"

''ProfStef''.

''ProfStef'' size.

''abc'' asUppercase.

''こんにちは'' reverse. 

"at:メッセージを使えば、各文字を得ることができます。"

''ProfStef'' at: 1.

"文字列の連結にはカンマ( , )演算子を使います。"

''ProfStef'', ''はすごいな''.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:55'!
basicTypesSymbol
	^ Lesson title: 'Basic types: Symbols' lesson: '"シンボルとは、システム全体で唯一となることが保証された文字列のことです。

シンボル#ProfStefはたった一つだけ存在します。文字列オブジェクトである''ProfStef''は複数個存在します。

（==メッセージは、二つのオブジェクトが同一である場合にtrue（真）を返します）"

''ProfStef'' asSymbol.

#ProfStef asString.

(2 asString) == (2 asString).

(2 asString) asSymbol == (2 asString) asSymbol.


(Smalltalk at: #ProfStef) next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 22:08'!
blocks
	^ Lesson title: 'Blocks' lesson: '"カスケードはOKです。ではブロックについて話しましょう。

ブロックは無名のメソッドで、変数に格納したり必要に応じて実行することができます。

ブロックは角括弧で囲まれています。"

[Browser open].

"この式ではブロックが実行されないので、ブラウザ（Browser）は開きません。

以下は、引数xに２を加えるブロックです。"

[:x | x+2].

"valueメッセージを送ることでブロックを実行することができます。"

[:x | x+2] value: 5.

[Browser open] value.

[:x | x+2] value: 10.

[:x :y| x + y] value:3 value:5.

[ProfStef next] value.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 22:09'!
blocksAssignation
	^ Lesson title: 'Block assignation' lesson: '"ブロックは変数に格納し、後で実行することができます。

|b|は変数bの宣言で、'':=''は値を変数に代入することを表しています。

以下の３行を選択し、print itしてください。"

|b|
b := [:x | x+2].
b value: 12.


ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 10:57'!
conditionals
	^ Lesson title: 'Conditionals' lesson: '"条件分岐は、真偽値（Boolean）オブジェクトへのメッセージ送信です。"

1 < 2
  ifTrue: [100]
  ifFalse: [42].

"この例でのメッセージはifTrue:ifFalseです。

以下を試してみましょう。"

Transcript open.

3 > 10 
	ifTrue: [Transcript show: ''maybe there''''s a bug ....'']
	ifFalse: [Transcript show: ''No : 3 is less than 10''].

3 = 3 ifTrue: [ProfStef next].'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 22:16'!
debugger
	^ Lesson title: 'Debugger' lesson: '"デバッガはSmalltalk環境で一番有名なツールなのかもしれません。デバッガは予期せぬ例外が発生したときに開きます。

以下のプログラムは、メッセージスタックを伴ったデバッガを開きます。SmalltalkSyntaxTutorial>>divideTwoByZeroを選択してください。".

SmalltalkSyntaxTutorial new divideTwoByZero.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:43'!
doingVSPrinting
	^ Lesson title: 'Doing VS Printing: Doing' lesson: '"すばらしい！まさにあなたはSmalltalk式を実行しました。より正確に言うと、あなたはnextメッセージをProfStefクラス（つまり私）に送りました。

ちなみに、あなたは ''ProfStef go'' を実行することで、この入門をやりなおすことができます。また、 ''ProfStef previous'' で、直前のレッスンに戻れます。

さらに、 ''do it'' の代わりに、 ''ALT d'' というキーボードショートカットを使うこともできます。（利用しているOSやコンピューターによって、 ''CMD d'' や ''CTRL d'' に変わることがあります）

以下の式を実行してみましょう："

Browser open.

SmalltalkImage current aboutThisSystem.

"では、次のレッスンに進んでください。"

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 22:13'!
instanciation
	^ Lesson title: 'Instanciation' lesson: '"オブジェクトは、それぞれのクラスのインスタンスです。普通、あるクラスのインスタンスを作るとき、そのクラスに#newメッセージを送ります。

#allInstancesメッセージをクラスに送ると、そのクラスの全てのインスタンスの配列を返します。

例えば、SimpleButtonMorphの全てのインスタンスが何個あるか調べてみましょう。"

SimpleButtonMorph allInstances size.

"ここで、新しいインスタンスを一つ作ります。"

SimpleButtonMorph new
	label: ''A nice button'';
	openCenteredInWorld.

"ワールドの中心にボタンが現れます。全てのインスタンスのリストは１つだけ増えているはずです。"

SimpleButtonMorph allInstances size.

"以下を試してみましょう。"

SimpleButtonMorph allInstances last 
	label: ''ProfStef is cooooool !!'';
	color: Color cyan.
	
"上のインスタンスを削除し、メモリを整理するようシステムに要求します。"

SimpleButtonMorph allInstances last delete.
Smalltalk garbageCollect.
SimpleButtonMorph allInstances size.

"ボタンを押すと次のレッスンに進みます。"

SimpleButtonMorph new
	label: ''Go to next lesson'';
	target: [ProfStef next. 
			SimpleButtonMorph allInstances last delete];
	actionSelector: #value;
	openCenteredInWorld.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 22:12'!
iterators
	^ Lesson title: 'Iterators' lesson: '"do:メッセージは、オブジェクトのコレクション（Array, Set, OrderedCollection）に送られ、コレクションの各要素に対してブロックが評価されます。

全ての要素をトランスクリプトに表示したい場合は以下のようにします。"

#(11 38 3 -2 10) do: [:each |
     Transcript show: each printString; cr].

"その他、いくつかの本当に素晴らしい反復子があります。"

#(11 38 3 -2 10) collect: [:each | each abs].

#(11 38 3 -2 10) collect: [:each | each odd].

#(11 38 3 -2 10) select: [:each | each odd].

#(11 38 3 -2 10) select: [:each | each > 10].

#(11 38 3 -2 10) reject: [:each | each > 10].

#(11 38 3 -2 10) 
     do: [:each | Transcript show: each printString]
     separatedBy: [Transcript show: ''.''].


ProfStef allInstances do: [:aProfStef | aProfStef next].'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 11:07'!
loops
	^ Lesson title: 'Loops' lesson: '"繰り返し処理は、コレクションに対する高階の反復処理ですが、普通のメソッドを用いて実現されています。"

"基本的な繰り返し処理：
  to:do:
  to:by:do"

1 to: 100 do:
  [:i | Transcript show: i asString; cr ].

1 to: 100 by: 3 do: [:i | Transcript show: i asString; cr].

100 to: 0 by: -2 do: 
    [:i | Transcript show: i asString; cr].

1 to: 1 do: [:i | ProfStef next].'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 20:03'!
mathematicalPrecedence
	^ Lesson title: 'Mathematical precedence' lesson: '"数学で用いられている伝統的な優先順位は、Smalltalkで用いられていません。"

2 * 10 + 2.

"この例では、メッセージ＊は２に送られて２０を返し、その後２０はメッセージ＋を受け取ります。

全てのメッセージは例外なく、左から右へという単純な優先順位に従う事を覚えておいてください。"

2 + 2 * 10.

2 + (2 * 10).

8 - 5 / 2.

(8 - 5) / 2.

8 - (5 / 2).

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:59'!
messageSyntaxBinary
	^ Lesson title: 'Message syntax: Binary messages' lesson: '"２項メッセージは、以下のような形をしています。
    あるオブジェクト + 別のオブジェクト"

3 * 2.

Date today + 3 weeks.

false | false.

true & true.

true & false.

10 @ 100.

10 <= 12.

''あい'', ''うえお''.

Date today < Date yesterday.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 20:04'!
messageSyntaxCascade
	^ Lesson title: 'Message syntax: Cascade' lesson: '"セミコロン; はカスケード演算子です。これは同じオブジェクトにメッセージを送るのに便利です。
トランスクリプト(Transcript)を開いて下さい。"

Transcript open.

"続いて、"

Transcript show: ''こんにちは''.
Transcript show: ''Smalltalk''.
Transcript cr.

"これらは以下と同等です。"

Transcript 
	   show: ''こんにちは'';
	   show: ''Smalltalk'' ;
	   cr.

"次のレッスンに進むために、２つのnextメッセージをカスケードで送ってみましょう。"

ProfStef'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 10:50'!
messageSyntaxCascadeShouldNotBeHere
	^ Lesson title: 'Lost ?' lesson: '"あれれ、このページに来てはいけませんよ。

元に戻ってカスケードを使ってください。"

ProfStef previous.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 20:01'!
messageSyntaxExecutionOrder
	^ Lesson title: 'Message syntax: Execution order' lesson: '"単項メッセージが最初に実行され、続いて２項メッセージ、キーワードメッセージの順に実行されます。
    単項 > ２項 > キーワード"

2 + 3 squared.

2 raisedTo: 3 + 2.
  
(0@0) class.

0@0 corner: 100@200.

(0@0 corner: 100@200) class.

"同じ優先順位のメッセージがある場合、式は左から右へと順に実行されていきます。"

-3 abs negated reciprocal.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 10:29'!
messageSyntaxExecutionOrderParentheses
	^ Lesson title: 'Message syntax: Parentheses' lesson: '"評価（実行）の順序を変えるには括弧を使います"

(2 + 3) squared.

(2 raisedTo: 3) + 2.

(0@0 extent: 100@200) bottomRight.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 20:00'!
messageSyntaxKeyword
	^ Lesson title: 'Message syntax: Keyword messages' lesson: '"キーワードメッセージは引数を持ったメッセージです。以下のような形をしています。
    オブジェクト  キー1:  別のオブジェクト1  キー2:  別のオブジェクト"

4 between: 0 and: 10.

"この例では、4という数に対してbetween:and:というメッセージを送っています。"

1 max: 3.

Color r:1 g:0 b:0.

"この例は、Colorクラスに実装されたr:g:b: メッセージです。次のように書く事もできます。"

Color
	r:1
	g:1
	b:0.
	
ProfStef perform: #next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:58'!
messageSyntaxUnary
	^ Lesson title: 'Message syntax: Unary messages' lesson: '"メッセージはオブジェクトに送られます。３種類（単項、２項、キーワード）のメッセージがあります。

単項メッセージは以下のような形をしています。
    オブジェクト  メッセージ

いままでにも単項メッセージを送ったことがあります。例えば、"

1 class.

false not.

Time now.

Date today.

Float pi.

"もちろんこれも↓ "

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 22:15'!
pharoEnvironment
	^ Lesson title: 'Pharo environment' lesson: '"どのSmalltalkシステムもオブジェクトで満たされています。ウィンドウやテキスト、数や日付、色や点などなど。他のプログラミング言語よりもずっと直接的な方法でオブジェクトと対話することができます。

どんなオブジェクトも''explore''メッセージを理解します。このメッセージを送ると、オブジェクトに関する詳細を表示するExplorerウィンドウが現れます。"

Date today explore.

"これは日付オブジェクトを表しており、時刻(start)と（１日という）間隔(duration)を表しています。"

ProfStef explore.

"ProfStefクラスにはたくさんのオブジェクトがあります。私のプログラムを見てみましょう。"

ProfStef browse.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:49'!
printing
	^ Lesson title: 'Doing VS Printing: Printing' lesson: '"すでに、あなたは Do It マスターです！ では、プリンティングについて話しましょう。プリンティングとは、選択した式の後ろに実行結果を表示する Do It のことです。
例えば、以下のテキストを選択し、メニューを開いて ''print it (p)'' を選んでください。"

1 + 2.

"''print it''の後ろに、括弧で囲まれたpの文字が見えませんでしたか？ それは、このコマンドを実行するためのALTショートカットを表しています。

以下の式で ALT-p を試してみましょう。"

Date today.

Time now.

"実行結果は選択されているので、バックスペースキーを押せば消すことができます。試してみましょう！"

SmalltalkImage  current datedVersion.

ProfStef next.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 22:14'!
reflection
	^ Lesson title: 'Reflection' lesson: '"実行中にシステムを調べたり変えたりすることができます。

Trueクラスの#ifFalse:ifTrue:メソッドのソースコードを表示します。"

(True>>#ifFalse:ifTrue:) definition.

"単にコメントだけを表示します。"

(True>>#ifFalse:ifTrue:) comment.

"私が実装した全てのメソッドです。"

ProfStef selectors.


"次のレッスンに進む新しいメソッドを作りましょう。"

ProfStef class compile:''goToNextLesson
  self next''.

"新しいメソッドを試さずにいられなーい！"

ProfStef goToNextLesson.'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 18:57'!
reflectionContinued
	^ Lesson title: 'Reflection continued' lesson: '"すごいですね？先に進む前に、さきほどのメソッドを削除します。"

ProfStef respondsTo: #goToNextLesson.

ProfStef class removeSelector: #goToNextLesson.

ProfStef respondsTo: #goToNextLesson.


"それでは次に進みましょう。"

ProfStef default executeMethod: (ProfStef lookupSelector:#next).'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:02'!
theEnd
	^ Lesson title: 'Tutorial done !!' lesson: '"このチュートリアルはこれで終わりです。PharoでのSmalltalkプログラミングを楽しんでください。

http://pharo-project.org/PharoByExample で公開している''Pharo By Example''を読むのを忘れずに。

このチュートリアルは ProfStef go を評価することでまた実行することができます。

ProfStef を使って自分自身の対話的チュートリアルを作りたいですか？とても簡単です。どうやるって？そのためのProfStef 対話的チュートリアルがありますよ。
以下のコードを評価してください。

ProfStef goOn: HowToMakeYourOwnTutorial

ではまたお会いしましょう。"
'! !

!SmalltalkSyntaxTutorial methodsFor: 'lessons' stamp: 'EiichiroIto 4/9/2011 19:44'!
welcome
	^ Lesson title: 'Welcome' lesson: '"こんにちは。Stef教授です。

Smalltalkを学ぶ手助けをします。

では、最初のレッスンを始めましょう。下のテキストを選択し、右クリックしてdo itを選んでください。"

ProfStef next.'! !


!SmalltalkSyntaxTutorial methodsFor: 'tutorial' stamp: 'LaurentLaffont 2/6/2011 19:05'!
tutorial
^ #(
welcome
doingVSPrinting
printing

basicTypesNumbers
basicTypesCharacters
basicTypesString
basicTypesSymbol
basicTypesArray
basicTypesDynamicArray

messageSyntaxUnary
messageSyntaxBinary
messageSyntaxKeyword
messageSyntaxExecutionOrder
messageSyntaxExecutionOrderParentheses
mathematicalPrecedence
messageSyntaxCascade
messageSyntaxCascadeShouldNotBeHere

blocks
blocksAssignation
conditionals
loops
iterators

instanciation

reflection
reflectionContinued

pharoEnvironment
debugger

theEnd
)! !
